//------------------------------------------------------------------------------//
//				AXC-PL01_SAMPLE2_Counter Module  V1.20	@				//
//			CompactFlash CF+ Programmable Logic CARD					//
//					ADTEK SYSTEM SCIENCE CO.,LTD.						//
//				Since 2005/01/13  LAST UPDATE 2005/11/07				//
//						<< S2_COUNTER U4 >>							//
//------------------------------------------------------------------------------//

//------------------------------------------------------------------------------//
//	Module	C_ -> CompactFlash, L_ ->LocalSignal, P -> PIO Signal			//
//			n  -> Active Low Signal									//
//------------------------------------------------------------------------------//

module S2_COUNTER

	(	IO_DATAOUT_CT_I,
		MRST,
		L_GPIO,
		COUNT_O
	);


//-----------------------Input Signal Definition--------------------------------//

	input	[1:0]IO_DATAOUT_CT_I;			// Counter Trigger Register
										// U1  U4

	input	MRST;						// RtBM[VZbgM
										// MAIN  U1,U4

	input	L_GPIO;						// GPIO Switch
										// MAIN  U2,U4


//-----------------------Output Signal Definition-------------------------------//

	output	[13:0]COUNT_O;					// Counter Register o͐M
										// U4  U2


//-----------------------Wire definition----------------------------------------//

	wire		countE;
	assign	countE	= IO_DATAOUT_CT_I[0] & ( MRST == 0 ) & L_GPIO ;

	wire		countR;
	assign	countR	= IO_DATAOUT_CT_I[1];


//------------------------Register definition-----------------------------------//

	reg		[13:0]COUNT_O;					// Count Register

//------------------------------------------------------------------------------//


	always @(posedge MRST or negedge countR or negedge countE ) begin

		if (MRST) begin
			COUNT_O[13:0]	<=	14'b00_0000_0000_0000;

		end else begin
		 	if (!countR) begin					
				COUNT_O[13:0]	<=	14'b00_0000_0000_0000;

			end else begin 
				if (countE) begin					
		 			COUNT_O[13:0]	<=	COUNT_O + 1; 
				end			
			end
	    end
	end

//------------------------------------------------------------------------------//

endmodule

